//                              -*- Mode: C++ -*- 
// 
// uC++ Version 4.7, Copyright (C) Peter A. Buhr and Richard A. Stroobosscher 1994
// 
// uBootTask.cc -- 
// 
// Author           : Peter Buhr
// Created On       : Thu Apr 28 13:31:12 1994
// Last Modified By : Peter A. Buhr
// Last Modified On : Wed Feb 10 10:15:52 1999
// Update Count     : 102
// 


#define __U_KERNEL__
#include <uC++.h>
#include <uBootTask.h>


void uBootTask::main() {
} // uBootTask::main


uBootTask::uBootTask() : uBaseTask( *uKernelModule::uSystemCluster ) {
    // SKULLDUGGERY: Explicitly make this task look like the currently
    // executing task.

    uKernelModule::uActiveTask = uKernelModule::uActiveProcessor->uCurrTask = this;

    // SKULLDUGGERY: Free stack because the UNIX stack is used.

    free( uStorage );
    uStorage = NULL;

    // SKULLDUGGERY: Remove "main" from the suspend stack so it is never
    // executed. This trick makes this task into a pseudo-task to execute the
    // global constructor and destructor lists.

    uSerialInstance.uAcceptSignalled.uDrop();

    // SKULLDUGGERY: Because this task has been removed from the suspend stack,
    // it is not woken by uSerialConstructor so do this manually by putting the
    // task on the ready queue.

    uWake();
} // uBootTask::uBootTask


uBootTask::~uBootTask() {
    // SKULLDUGGERY: Since this task does not have a "main" routine, some of
    // its termination code must be performed manually.

    uNotHalted = false;
} // uBootTask::~uBootTask


// Local Variables: //
// compile-command: "dmake" //
// End: //
