//                              -*- Mode: C++ -*- 
// 
// uC++ Version 4.7, Copyright (C) Peter A. Buhr 1996
// 
// uNetwork.h -- 
// 
// Author           : Peter A. Buhr
// Created On       : Thu Oct 31 13:30:43 1996
// Last Modified By : Peter A. Buhr
// Last Modified On : Mon Jun 15 15:07:13 1998
// Update Count     : 18
// 


#ifndef __U_NETWORK_H__
#define __U_NETWORK_H__


#include <netinet/in.h>


#pragma __U_NOT_USER_CODE__


// TEMPORARY: Several systems do not have thread safe versions of these
// routines. As result, time-slicing during the execution of these routines
// causes EINTRs during internal system calls (like opens and reads of network
// name files), which results in failure of these system calls. Turning off
// time-slicing seems to solve the problem. As well, the UNIX versions are not
// thread-safe (static storage areas); these routines are thread-safe.

extern int uGethostname( const char *const name, int len );
extern int uGethostbyname( const char *const name, struct hostent *h );


#pragma __U_USER_CODE__


#endif __U_NETWORK_H__


// Local Variables:
// compile-command: "dmake"
// End:
