//                              -*- Mode: C++ -*- 
// 
// uC++ Version 4.7, Copyright (C) Peter A. Buhr and Richard A. Stroobosscher 1994
// 
// attribute.h -- 
// 
// Author           : Richard A. Stroobosscher
// Created On       : Tue Apr 28 16:02:53 1992
// Last Modified By : Peter A. Buhr
// Last Modified On : Wed Feb 10 10:55:01 1999
// Update Count     : 26
// 

#ifndef __ATTRIBUTE_H__
#define __ATTRIBUTE_H__

#define NO_ATTRIBUTE 0x00
#define MUTEX_ATTRIBUTE 0x01
#define NOMUTEX_ATTRIBUTE 0x02

#define TYPEDEF_ATTRIBUTE 0x01
#define FRIEND_ATTRIBUTE 0x02

#define PERIODIC_ATTRIBUTE 0x01
#define APERIODIC_ATTRIBUTE 0x02
#define SPORADIC_ATTRIBUTE 0x04

class table_t;						// forward declaration
class symbol_t;						// forward declaration
class token_t;						// forward declaration

struct attribute_t {
    int value;						// mutex attribute
    int value1;						// typedef/friend attribute
    symbol_t *typedef_base;				// typedef base type
    int value2;						// realtime attribute
    bool emptyparms;					// indicates parameter list is empty
    table_t *plate;					// template attributes
    token_t *startE;					// start of entry list type
    token_t *startM;					// start of mutex list type
    token_t *endM;					// end of mutex type attribute
    attribute_t();
    ~attribute_t();
};

#endif __ATTRIBUTE_H__

// Local Variables: //
// compile-command: "dmake" //
// End: //
