//                              -*- Mode: C++ -*- 
// 
// uC++ Version 4.7, Copyright (C) Peter A. Buhr and Richard A. Stroobosscher 1994
// 
// key.h -- 
// 
// Author           : Richard A. Stroobosscher
// Created On       : Tue Apr 28 15:39:05 1992
// Last Modified By : Peter A. Buhr
// Last Modified On : Mon Nov  9 17:50:03 1998
// Update Count     : 28
// 


#ifndef __KEY_H__
#define __KEY_H__

struct keyword_t {
    const char *text;
    int value;
};

extern keyword_t key[];

enum key_value_t {
    ASM = 512,
    ATTRIBUTE,						// gcc specific
    AUTO,
    BOOL,
    BREAK,
    CASE,
    CATCH,
    CHAR,
    CLASS,
    CONST,
    CONST_CAST,
    CONTINUE,
    DEFAULT,
    DELETE,
    DO,
    DOUBLE,
    DYNAMIC_CAST,
    ELSE,
    ENUM,
    EXPLICIT,
    EXPORT,
    EXTENSION,						// gcc specific
    EXTERN,
    FALSE_C,						// FALSE often appears in a #define in /usr/include
    FLOAT,
    FOR,
    FRIEND,
    GOTO,
    IF,
    INLINE,
    INT,
    LONG,
    MUTABLE,
    NAMESPACE,
    NEW,
    OPERATOR,
    PRIVATE,
    PROTECTED,
    PUBLIC,
    REGISTER,
    REINTERPRET_CAST,
    RETURN,
    SHORT,
    SIGNED,
    SIZEOF,
    STATIC,
    STATIC_CAST,
    STRUCT,
    SWITCH,
    TEMPLATE,
    THIS,
    THROW,
    TRUE_C,						// TRUE often appears in a #define in /usr/include
    TRY,
    TYPEDEF,
    TYPEOF,
    TYPEID,
    TYPENAME,
    UNION,
    UNSIGNED,
    USING,
    VIRTUAL,
    VOID,
    VOLATILE,
    WCHAR_T,
    WHILE,
    
    ACCEPT,
    AT,
    COROUTINE,
    DISABLE,
    DUALEVENT,
    ENABLE,
    MUTEX,
    NOMUTEX,
    OR,
    PTASK,
    RAISE,
    RAISEEVENT,
    RTASK,
    RESUME,
    SIGNAL,
    SIGNALBLOCK,
    STASK,
    SUSPEND,
    TASK,
    THROWEVENT,
    TIMEOUT,
    WAIT,
    WITH,
    WHEN,
    UELSE,
    UTHROW,
};

#endif __KEY_H__

// Local Variables: //
// compile-command: "dmake" //
// End: //
