//                              -*- Mode: C++ -*- 
// 
// uC++ Version 4.7, Copyright (C) Peter A. Buhr and Richard A. Stroobosscher 1994
// 
// symbol.c -- 
// 
// Author           : Richard A. Stroobosscher
// Created On       : Tue Apr 28 15:18:22 1992
// Last Modified By : Peter A. Buhr
// Last Modified On : Wed Nov 26 14:28:25 1997
// Update Count     : 30
// 

#include <stdlib.h>
#include <stdio.h>

#include "symbol.h"

symbol_t::symbol_t( int v, hash_t *h ) {
    value = v;
    hash = h;
    link = NULL;
    found = NULL;
    table = NULL;
    key = 0;
    index = DESTRUCTORPOSN;				// start allocating entry bits from this value
    base = NULL;
    used = false;
    left = (token_t *)0;
    right = (token_t *)0;
} // symbol_t::symbol_t

symbol_t::symbol_t( const symbol_t & other ) {
    value = other.value;
    hash = other.hash;
    link = NULL;
    found = NULL;
    table = NULL;
    key = 0; 
    base = NULL;
    used = false;
    left = (token_t *) 0;
    right = (token_t *) 0;
    attribute = other.attribute;
} // symbol_t::symbol_t

symbol_t::~symbol_t() {
    value = -1;
    hash = NULL;
    link = NULL;
    found = NULL;
    table = NULL;
    key = 0;
    index = DESTRUCTORPOSN;
    base = NULL;
    used = false;
    base_token = (token_t *)0;
    left = (token_t *)0;
    right = (token_t *)0;
} // symbol_t::~symbol_t

// Local Variables: //
// compile-command: "dmake" //
// End: //
